----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 09/29/2024 03:07:12 PM
-- Design Name: 
-- Module Name: neorv32_tb_min - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library neorv32;
library work;
use std.textio.all;
use ieee.numeric_std.all;
use ieee.math_real.all;

library neorv32;
use neorv32.neorv32_package.all;
use neorv32.neorv32_application_image.all; -- this file is generated by the image generator

use std.textio.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity neorv32_tb_min is
--  Port ( );
end neorv32_tb_min;

architecture Behavioral of neorv32_tb_min is
  constant f_clock_c               : natural := 100_000_000; --clock frequency of the uut
  constant baud0_rate_c            : natural := 19200; -- simulation UART0 (primary UART) baud rate
  -- internals - hands off! --
  constant uart0_baud_val_c : real := real(f_clock_c) / real(baud0_rate_c);
  constant t_clock_c        : time := (1 sec) / f_clock_c;
  -- generators --
  signal clk_gen, rstn_gen : std_ulogic := '0';
  -- uart --
  signal uart0_txd : std_ulogic;
  
  -- pwm -- TODO: CAPIRE SE SERVE
  signal con_pwm_o  : std_ulogic_vector(3-1 downto 0);
  --file file_uart_tx_out : text open write_mode is "neorv32.testbench_uart0.out";
  
  component neorv32_top_min is
  port (
    -- Global control --
    clk_i  : in  std_logic;
    rstn_i : in  std_logic;
    -- PWM (available if IO_PWM_NUM_CH > 0) --
    pwm_o  : out std_ulogic_vector(3-1 downto 0);
    -- primary UART0 (available if IO_UART0_EN = true) --
    uart0_txd_o    : out std_ulogic;                                        -- UART0 send data
    uart0_rxd_i    : in  std_ulogic;                                 -- UART0 receive data
    uart0_rts_o    : out std_ulogic;                                        -- HW flow control: UART0.RX ready to receive ("RTR"), low-active, optional
    uart0_cts_i    : in  std_ulogic                                 -- HW flow control: UART0.TX allowed to transmit, low-active, optional
  );
  end component;
  
  component uart_rx_simple is
  generic (
    name : string;
    uart_baud_val_c : real);

    port (
      clk : in std_ulogic;
      uart_txd : in std_ulogic
     );
  end component;

  file file_uart_tx_out : text open write_mode is "neorv32.testbench_uart0.out";
begin


  -- Clock/Reset Generator ------------------------------------------------------------------
  -- -------------------------------------------------------------------------------------------

  clk_gen <= not clk_gen after (t_clock_c/2);
  rstn_gen <= '0', '1' after 200*(t_clock_c/2);
  
  -- The core of the problem -----------------------------------------------------------------
  -- -----------------------------------------------------------------------------------------
  uut: neorv32_top_min
  port map(    
     -- Global control --
    clk_i  => clk_gen,    -- global clock, rising edge
    rstn_i => rstn_gen,   -- global reset, low-active, async
    -- PWM (available if IO_PWM_NUM_CH > 0) --
    pwm_o  => con_pwm_o, -- pwm channels);
    
    -- primary UART0 (available if IO_UART0_EN = true) --
    uart0_txd_o    => uart0_txd,       -- UART0 send data
    uart0_rxd_i => uart0_txd,
    uart0_cts_i    => '0'       -- HW flow control: UART0.TX allowed to transmit, low-active, optional
  );
  
 -- UART Simulation Receiver ---------------------------------------------------------------
  -- -------------------------------------------------------------------------------------------
  uart0_checker: uart_rx_simple
  generic map (
    name => "uart0",
    uart_baud_val_c => uart0_baud_val_c
  )
  port map (
    clk => clk_gen,
    uart_txd => uart0_txd
  );

  

end Behavioral;
